;
;   EXAMPLE APPLICATION
;
;   Compile with FASM for Menuet
;

use32

	       org    0x0

	       db     'MENUET01'	      ; 8 byte id
	       dd     0x01		      ; header version
	       dd     START		      ; start of code
	       dd     I_END		      ; size of image
	       dd     0x100000		      ; memory for app
	       dd     0x7fff0		      ; esp
	       dd     0x0 , 0x0 	      ; I_Param , I_Icon

START:				; start of execution

     call draw_window

still:

    mov  eax,10 		; wait here for event
    int  0x40

    cmp  eax,1			; redraw request ?
    je	 red
    cmp  eax,2			; key in buffer ?
    je	 key
    cmp  eax,3			; button in buffer ?
    je	 button

    jmp  still

  red:				; redraw
    call draw_window
    jmp  still

  key:				; key
    mov  eax,2			; just read it and ignore
    int  0x40
    jmp  still

  button:			; button
    mov  eax,17 		; get id
    int  0x40

    cmp ah,2
    je button2

    cmp ah,3
    je button3

    cmp ah,4
    je button4

    cmp ah,5
    je button5

    cmp  ah,1			; button id=1 ?
    jne  noclose

    mov  eax,-1 		; close this program
    int  0x40
  noclose:

    jmp  still

  button2:	;option 1
   call set_optionbox
  jmp still

  button3:	;option 2
   call set_optionbox
  jmp still

  button4:	;option 3
   call set_optionbox
  jmp still

  button5:
   mov	eax,4			   ; function 4 : write text to window
   mov	ebx,170*65536+55		   ; [x start] *65536 + [y start]
   mov	ecx,0x10000000	   ; font 1 & color ( 0xF0RRGGBB )
   mov	edx,options-1
   add	dl, [optionbox_checked] 	   ; pointer to text beginning
   mov	esi,1	   ; text length
   int	0x40

  jmp still


;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************


draw_window:


    mov  eax,12 		   ; function 12:tell os about windowdraw
    mov  ebx,1			   ; 1, start of draw
    int  0x40

				   ; DRAW WINDOW
    mov  eax,0			   ; function 0 : define and draw window
    mov  ebx,100*65536+300	   ; [x start] *65536 + [x size]
    mov  ecx,100*65536+120	   ; [y start] *65536 + [y size]
    mov  edx,0x02ffffff 	   ; color of work area RRGGBB,8->color gl
    mov  esi,0x805080d0 	   ; color of grab bar  RRGGBB,8->color gl
    mov  edi,0x005080d0 	   ; color of frames    RRGGBB
    int  0x40

				   ; WINDOW LABEL
    mov  eax,4			   ; function 4 : write text to window
    mov  ebx,8*65536+8		   ; [x start] *65536 + [y start]
    mov  ecx,0x10ddeeff 	   ; font 1 & color ( 0xF0RRGGBB )
    mov  edx,labelt		   ; pointer to text beginning
    mov  esi,labellen-labelt	   ; text length
    int  0x40

				   ; CLOSE BUTTON
    mov  eax,8			   ; function 8 : define and draw button
    mov  ebx,(300-19)*65536+12	   ; [x start] *65536 + [x size]
    mov  ecx,5*65536+12 	   ; [y start] *65536 + [y size]
    mov  edx,1			   ; button id
    mov  esi,0x6688dd		   ; button color RRGGBB
    int  0x40

    ;draw optionbox1
    mov eax, 50 shl 16 + 50	   ; [x start] shl 16 + [y start]
    mov cl, 2			   ; button id
    mov edx, optiontext1	   ; pointer to text beginning
    call optionbox

    ;draw optionbox2
    mov eax, 50 shl 16 + 70	   ; [x start] shl 16 + [y start]
    mov cl, 3			   ; button id
    mov edx, optiontext2	   ; pointer to text beginning
    call optionbox

    ;draw optionbox3
    mov eax, 50 shl 16 + 90	   ; [x start] shl 16 + [y start]
    mov cl, 4			   ; button id
    mov edx, optiontext3	   ; pointer to text beginning
    call optionbox

    mov  eax,8			   ; function 8 : define and draw button
    mov  ebx,170*65536+15	   ; [x start] *65536 + [x size]
    mov  ecx,55*65536+15	   ; [y start] *65536 + [y size]
    mov  edx,5			   ; button id
    mov  esi,0x6688dd		   ; button color RRGGBB
    int  0x40

    mov  eax,12 		   ; function 12:tell os about windowdraw
    mov  ebx,2			   ; 2, end of draw
    int  0x40

    ret

include "optbox.inc"

; DATA AREA

optiontext1: db 'OptionBox1',0	   ; o is end
optiontext2: db 'OptionBox2',0
optiontext3: db 'OptionBox3',0

options: db '0123'

labelt:
     db   'EXAMPLE APPLICATION'
labellen:

I_END:



